diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/visualizer/visualizer/core.py ns-3.41/src/visualizer/visualizer/core.py
--- ns-3.40/src/visualizer/visualizer/core.py	2023-09-27 13:30:37.894839800 -0700
+++ ns-3.41/src/visualizer/visualizer/core.py	2024-02-09 14:44:08.561794800 -0800
@@ -1275,7 +1360,7 @@
             self.simulation.lock.release()
 
     def do_simulation_periodic_update(self):
-        smooth_factor = int(self.transmissions_smoothing_adjustment.get_value()*10)
+        smooth_factor = int(self.transmissions_smoothing_adjustment.get_value() * 10)
 
         transmissions = self.simulation.sim_helper.GetTransmissionSamples()
         self._last_transmissions.append(transmissions)
@@ -1291,17 +1376,13 @@
         hadj = self._scrolled_window.get_hadjustment()
         vadj = self._scrolled_window.get_vadjustment()
         bounds_x1, bounds_y1 = self.canvas.convert_from_pixels(hadj.get_value(), vadj.get_value())
-        bounds_x2, bounds_y2 = self.canvas.convert_from_pixels(hadj.get_value() + hadj.get_page_size(),
-                                                               vadj.get_value() + vadj.get_page_size())
-        try:
-            pos1_x, pos1_y, pos2_x, pos2_y = ns.PyViz.LineClipping(bounds_x1, bounds_y1,
-                                                               bounds_x2, bounds_y2,
-                                                               pos1_x, pos1_y,
-                                                               pos2_x, pos2_y)
-        except:
-            res = (0,0,0,0)
-        pos1_x, pos1_y, pos2_x, pos2_y = res
-        return (pos1_x + pos2_x)/2, (pos1_y + pos2_y)/2
+        bounds_x2, bounds_y2 = self.canvas.convert_from_pixels(
+            hadj.get_value() + hadj.get_page_size(), vadj.get_value() + vadj.get_page_size()
+        )
+        ns.PyViz.LineClipping(
+            bounds_x1, bounds_y1, bounds_x2, bounds_y2, pos1_x, pos1_y, pos2_x, pos2_y
+        )
+        return (pos1_x.value + pos2_x.value) / 2, (pos1_y.value + pos2_y.value) / 2
 
     def _update_transmissions_view(self):
         transmissions_average = {}
@@ -1319,7 +1400,7 @@
             label.set_property("visibility", GooCanvas.CanvasItemVisibility.HIDDEN)
         new_arrows = []
 
-        k = self.node_size_adjustment.get_value()/5
+        k = self.node_size_adjustment.get_value() / 5
 
         for (transmitter_id, receiver_id), (rx_bytes, rx_count) in transmissions_average.items():
             transmitter = self.get_node(transmitter_id)
@@ -1327,15 +1408,24 @@
             try:
                 arrow, label = old_arrows.pop()
             except IndexError:
-                arrow = GooCanvas.CanvasPolyline(line_width=2.0, stroke_color_rgba=0x00C000C0, close_path=False, end_arrow=True, pointer_events=GooCanvas.CanvasPointerEvents.NONE)
+                arrow = GooCanvas.CanvasPolyline(
+                    line_width=2.0,
+                    stroke_color_rgba=0x00C000C0,
+                    close_path=False,
+                    end_arrow=True,
+                    pointer_events=GooCanvas.CanvasPointerEvents.NONE,
+                )
                 arrow.set_property("parent", self.canvas.get_root_item())
                 arrow.raise_(None)
 
-                label = GooCanvas.CanvasText(parent=self.canvas.get_root_item(), pointer_events=GooCanvas.CanvasPointerEvents.NONE)
+                label = GooCanvas.CanvasText(
+                    parent=self.canvas.get_root_item(),
+                    pointer_events=GooCanvas.CanvasPointerEvents.NONE,
+                )
                 label.raise_(None)
 
             arrow.set_property("visibility", GooCanvas.CanvasItemVisibility.VISIBLE)
-            line_width = max(0.1, math.log(float(rx_bytes)/rx_count/self.sample_period)*k)
+            line_width = max(0.1, math.log(float(rx_bytes) / rx_count / self.sample_period) * k)
             arrow.set_property("line-width", line_width)
 
             pos1_x, pos1_y = transmitter.get_position()
@@ -1345,40 +1435,49 @@
             points.set_point(1, pos2_x, pos2_y)
             arrow.set_property("points", points)
 
-            kbps = float(rx_bytes*8)/1e3/rx_count/self.sample_period
-            label.set_properties(visibility=GooCanvas.CanvasItemVisibility.VISIBLE_ABOVE_THRESHOLD,
-                                 visibility_threshold=0.5,
-                                 font=("Sans Serif %f" % int(1+BITRATE_FONT_SIZE*k)))
+            kbps = float(rx_bytes * 8) / 1e3 / rx_count / self.sample_period
+            label.set_properties(
+                visibility=GooCanvas.CanvasItemVisibility.VISIBLE_ABOVE_THRESHOLD,
+                visibility_threshold=0.5,
+                font=("Sans Serif %f" % int(1 + BITRATE_FONT_SIZE * k)),
+            )
             angle = math.atan2((pos2_y - pos1_y), (pos2_x - pos1_x))
             if -PI_OVER_2 <= angle <= PI_OVER_2:
-                label.set_properties(text=("%.2f kbit/s →" % (kbps,)),
-                                     alignment=Pango.Alignment.CENTER,
-                                     anchor=GooCanvas.CanvasAnchorType.S,
-                                     x=0, y=-line_width/2)
+                label.set_properties(
+                    text=("%.2f kbit/s →" % (kbps,)),
+                    alignment=Pango.Alignment.CENTER,
+                    anchor=GooCanvas.CanvasAnchorType.S,
+                    x=0,
+                    y=-line_width / 2,
+                )
             else:
-                label.set_properties(text=("← %.2f kbit/s" % (kbps,)),
-                                     alignment=Pango.Alignment.CENTER,
-                                     anchor=GooCanvas.CanvasAnchorType.N,
-                                     x=0, y=line_width/2)
+                label.set_properties(
+                    text=("← %.2f kbit/s" % (kbps,)),
+                    alignment=Pango.Alignment.CENTER,
+                    anchor=GooCanvas.CanvasAnchorType.N,
+                    x=0,
+                    y=line_width / 2,
+                )
             M = cairo.Matrix()
-            lx, ly = self._get_label_over_line_position(c_double(pos1_x), c_double(pos1_y),
-                                                        c_double(pos2_x), c_double(pos2_y))
+            lx, ly = self._get_label_over_line_position(
+                c_double(pos1_x), c_double(pos1_y), c_double(pos2_x), c_double(pos2_y)
+            )
             M.translate(lx, ly)
             M.rotate(angle)
             try:
                 label.set_transform(M)
             except KeyError:
                 # https://gitlab.gnome.org/GNOME/pygobject/issues/16
-                warnings.warn("PyGobject bug causing label position error; "
-                              "should be fixed in PyGObject >= 3.29.1")
-                label.set_properties(x=(lx + label.props.x),
-                                     y=(ly + label.props.y))
+                warnings.warn(
+                    "PyGobject bug causing label position error; "
+                    "should be fixed in PyGObject >= 3.29.1"
+                )
+                label.set_properties(x=(lx + label.props.x), y=(ly + label.props.y))
 
             new_arrows.append((arrow, label))
 
         self._transmission_arrows = new_arrows + old_arrows
 
-
     def _update_drops_view(self):
         drops_average = {}
         for drop_set in self._last_drops:
@@ -1400,23 +1499,34 @@
         bottom_y = vadjustment.get_value() + vadjustment.get_page_size()
         dummy, edge_y = self.canvas.convert_from_pixels(0, bottom_y)
 
-        k = self.node_size_adjustment.get_value()/5
+        k = self.node_size_adjustment.get_value() / 5
 
         for transmitter_id, (drop_bytes, drop_count) in drops_average.items():
             transmitter = self.get_node(transmitter_id)
             try:
                 arrow, label = old_arrows.pop()
             except IndexError:
-                arrow = GooCanvas.CanvasPolyline(line_width=2.0, stroke_color_rgba=0xC00000C0, close_path=False, end_arrow=True, pointer_events=GooCanvas.CanvasPointerEvents.NONE)
+                arrow = GooCanvas.CanvasPolyline(
+                    line_width=2.0,
+                    stroke_color_rgba=0xC00000C0,
+                    close_path=False,
+                    end_arrow=True,
+                    pointer_events=GooCanvas.CanvasPointerEvents.NONE,
+                )
                 arrow.set_property("parent", self.canvas.get_root_item())
                 arrow.raise_(None)
 
-                label = GooCanvas.CanvasText(pointer_events=GooCanvas.CanvasPointerEvents.NONE)#, fill_color_rgba=0x00C000C0)
+                label = GooCanvas.CanvasText(
+                    pointer_events=GooCanvas.CanvasPointerEvents.NONE
+                )  # , fill_color_rgba=0x00C000C0)
                 label.set_property("parent", self.canvas.get_root_item())
                 label.raise_(None)
 
             arrow.set_property("visibility", GooCanvas.CanvasItemVisibility.VISIBLE)
-            arrow.set_property("line-width", max(0.1, math.log(float(drop_bytes)/drop_count/self.sample_period)*k))
+            arrow.set_property(
+                "line-width",
+                max(0.1, math.log(float(drop_bytes) / drop_count / self.sample_period) * k),
+            )
             pos1_x, pos1_y = transmitter.get_position()
             pos2_x, pos2_y = pos1_x, edge_y
             points = GooCanvas.CanvasPoints.new(2)
@@ -1424,21 +1534,24 @@
             points.set_point(1, pos2_x, pos2_y)
             arrow.set_property("points", points)
 
-            label.set_properties(visibility=GooCanvas.CanvasItemVisibility.VISIBLE_ABOVE_THRESHOLD,
-                                 visibility_threshold=0.5,
-                                 font=("Sans Serif %i" % int(1+BITRATE_FONT_SIZE*k)),
-                                 text=("%.2f kbit/s" % (float(drop_bytes*8)/1e3/drop_count/self.sample_period,)),
-                                 alignment=Pango.Alignment.CENTER,
-                                 x=(pos1_x + pos2_x)/2,
-                                 y=(pos1_y + pos2_y)/2)
+            label.set_properties(
+                visibility=GooCanvas.CanvasItemVisibility.VISIBLE_ABOVE_THRESHOLD,
+                visibility_threshold=0.5,
+                font=("Sans Serif %i" % int(1 + BITRATE_FONT_SIZE * k)),
+                text=(
+                    "%.2f kbit/s" % (float(drop_bytes * 8) / 1e3 / drop_count / self.sample_period,)
+                ),
+                alignment=Pango.Alignment.CENTER,
+                x=(pos1_x + pos2_x) / 2,
+                y=(pos1_y + pos2_y) / 2,
+            )
 
             new_arrows.append((arrow, label))
 
         self._drop_arrows = new_arrows + old_arrows
 
-
     def update_view_timeout(self):
-        #print "view: update_view_timeout called at real time ", time.time()
+        # print "view: update_view_timeout called at real time ", time.time()
 
         # while the simulator is busy, run the gtk event loop
         while not self.simulation.lock.acquire(False):
@@ -1448,15 +1561,20 @@
         self.simulation.pause_messages = []
         try:
             self.update_view()
-            self.simulation.target_time = ns.Simulator.Now ().GetSeconds () + self.sample_period
-            #print "view: target time set to %f" % self.simulation.target_time
+            self.simulation.target_time = ns.Simulator.Now().GetSeconds() + self.sample_period
+            # print "view: target time set to %f" % self.simulation.target_time
         finally:
             self.simulation.lock.release()
 
         if pause_messages:
-            #print pause_messages
-            dialog = Gtk.MessageDialog(parent=self.window, flags=0, type=Gtk.MessageType.WARNING, buttons=Gtk.ButtonsType.OK,
-                                       message_format='\n'.join(pause_messages))
+            # print pause_messages
+            dialog = Gtk.MessageDialog(
+                parent=self.window,
+                flags=0,
+                type=Gtk.MessageType.WARNING,
+                buttons=Gtk.ButtonsType.OK,
+                message_format="\n".join(pause_messages),
+            )
             dialog.connect("response", lambda d, r: d.destroy())
             dialog.show()
             self.play_button.set_active(False)
@@ -1466,18 +1584,20 @@
             self._update_timeout_id = None
             return False
 
-        #print "view: self.simulation.go.set()"
+        # print "view: self.simulation.go.set()"
         self.simulation.go.set()
-        #print "view: done."
+        # print "view: done."
         return True
 
     def _start_update_timer(self):
         if self._update_timeout_id is not None:
             GLib.source_remove(self._update_timeout_id)
-        #print "start_update_timer"
-        self._update_timeout_id = GLib.timeout_add(int(SAMPLE_PERIOD/min(self.speed, 1)*1e3),
-                                                   self.update_view_timeout,
-                                                   priority=PRIORITY_UPDATE_VIEW)
+        # print "start_update_timer"
+        self._update_timeout_id = GLib.timeout_add(
+            int(SAMPLE_PERIOD / min(self.speed, 1) * 1e3),
+            self.update_view_timeout,
+            priority=PRIORITY_UPDATE_VIEW,
+        )
 
     def _on_play_button_toggled(self, button):
         if button.get_active():
@@ -1503,15 +1623,18 @@
         # that is executed.
 
         original_runcode = self.ipython.runcode
+
         def runcode(ip, *args):
-            #print "lock"
+            # print "lock"
             self.simulation.lock.acquire()
             try:
                 return original_runcode(*args)
             finally:
-                #print "unlock"
+                # print "unlock"
                 self.simulation.lock.release()
+
         import types
+
         self.ipython.runcode = types.MethodType(runcode, self.ipython)
 
     def autoscale_view(self):
@@ -1519,8 +1642,8 @@
             return
         self._update_node_positions()
         positions = [node.get_position() for node in self.nodes.values()]
-        min_x, min_y = min(x for (x,y) in positions), min(y for (x,y) in positions)
-        max_x, max_y = max(x for (x,y) in positions), max(y for (x,y) in positions)
+        min_x, min_y = min(x for (x, y) in positions), min(y for (x, y) in positions)
+        max_x, max_y = max(x for (x, y) in positions), max(y for (x, y) in positions)
         min_x_px, min_y_px = self.canvas.convert_to_pixels(min_x, min_y)
         max_x_px, max_y_px = self.canvas.convert_to_pixels(max_x, max_y)
         dx = max_x - min_x
@@ -1529,31 +1652,30 @@
         dy_px = max_y_px - min_y_px
         hadj = self._scrolled_window.get_hadjustment()
         vadj = self._scrolled_window.get_vadjustment()
-        new_dx, new_dy = 1.5*dx_px, 1.5*dy_px
+        new_dx, new_dy = 1.5 * dx_px, 1.5 * dy_px
 
         if new_dx == 0 or new_dy == 0:
             return
 
-        self.zoom.set_value(min(hadj.get_page_size()/new_dx, vadj.get_page_size()/new_dy))
+        self.zoom.set_value(min(hadj.get_page_size() / new_dx, vadj.get_page_size() / new_dy))
 
         x1, y1 = self.canvas.convert_from_pixels(hadj.get_value(), vadj.get_value())
-        x2, y2 = self.canvas.convert_from_pixels((hadj.get_value() +
-                                                  hadj.get_page_size()),
-                                                 (vadj.get_value() +
-                                                  vadj.get_page_size()))
+        x2, y2 = self.canvas.convert_from_pixels(
+            (hadj.get_value() + hadj.get_page_size()), (vadj.get_value() + vadj.get_page_size())
+        )
         width = x2 - x1
         height = y2 - y1
         center_x = (min_x + max_x) / 2
         center_y = (min_y + max_y) / 2
 
-        self.canvas.scroll_to(center_x - width/2, center_y - height/2)
+        self.canvas.scroll_to(center_x - width / 2, center_y - height / 2)
 
         return False
 
     def start(self):
         self.scan_topology()
         self.window.connect("delete-event", self._quit)
-        #self._start_update_timer()
+        # self._start_update_timer()
         GLib.timeout_add(200, self.autoscale_view)
         self.simulation.start()
 
@@ -1566,7 +1688,6 @@
 
         Gtk.main()
 
-
     def on_root_button_press_event(self, view, target, event):
         if event.button == 1:
             self.select_node(None)
@@ -1614,7 +1735,9 @@
         devpos = self.canvas.get_window().get_device_position(event.device)
         x0, y0 = self.canvas.convert_from_pixels(devpos.x, devpos.y)
         self.node_drag_state = self.NodeDragState(x0, y0, pos.x, pos.y)
-        self.node_drag_state.motion_signal = node.canvas_item.connect("motion-notify-event", self.node_drag_motion, node)
+        self.node_drag_state.motion_signal = node.canvas_item.connect(
+            "motion-notify-event", self.node_drag_motion, node
+        )
 
     def node_drag_motion(self, item, targe_item, event, node):
         self.simulation.lock.acquire()
@@ -1627,12 +1750,12 @@
                 return False
             devpos = self.canvas.get_window().get_device_position(event.device)
             canvas_x, canvas_y = self.canvas.convert_from_pixels(devpos.x, devpos.y)
-            dx = (canvas_x - self.node_drag_state.canvas_x0)
-            dy = (canvas_y - self.node_drag_state.canvas_y0)
+            dx = canvas_x - self.node_drag_state.canvas_x0
+            dy = canvas_y - self.node_drag_state.canvas_y0
             pos = mob.GetPosition()
             pos.x = self.node_drag_state.sim_x0 + transform_distance_canvas_to_simulation(dx)
             pos.y = self.node_drag_state.sim_y0 + transform_distance_canvas_to_simulation(dy)
-            #print "SetPosition(%G, %G)" % (pos.x, pos.y)
+            # print "SetPosition(%G, %G)" % (pos.x, pos.y)
             mob.SetPosition(pos)
             node.set_position(*transform_point_simulation_to_canvas(pos.x, pos.y))
         finally:
@@ -1667,8 +1790,7 @@
                     ns3_node = ns.NodeList.GetNode(self.selected_node.node_index)
                 finally:
                     self.simulation.lock.release()
-            self.ipython.updateNamespace({'selected_node': ns3_node})
-
+            self.ipython.updateNamespace({"selected_node": ns3_node})
 
     def select_node(self, node):
         if isinstance(node, ns.Node):
@@ -1699,7 +1821,6 @@
 
         self._update_ipython_selected_node()
 
-
     def add_information_window(self, info_win):
         self.information_windows.append(info_win)
         self.simulation.lock.acquire()
@@ -1712,12 +1833,12 @@
         self.information_windows.remove(info_win)
 
     def _canvas_tooltip_cb(self, canvas, x, y, keyboard_mode, tooltip):
-        #print "tooltip query: ", x, y
+        # print "tooltip query: ", x, y
         hadj = self._scrolled_window.get_hadjustment()
         vadj = self._scrolled_window.get_vadjustment()
         x, y = self.canvas.convert_from_pixels(hadj.get_value() + x, vadj.get_value() + y)
         item = self.canvas.get_item_at(x, y, True)
-        #print "items at (%f, %f): %r | keyboard_mode=%r" % (x, y, item, keyboard_mode)
+        # print "items at (%f, %f): %r | keyboard_mode=%r" % (x, y, item, keyboard_mode)
         if not item:
             return False
         while item is not None:
@@ -1729,10 +1850,9 @@
         return False
 
     def _get_export_file_name(self):
-        sel = Gtk.FileChooserNative.new("Save...", self.canvas.get_toplevel(),
-                                        Gtk.FileChooserAction.SAVE,
-                                        "_Save",
-                                        "_Cancel")
+        sel = Gtk.FileChooserNative.new(
+            "Save...", self.canvas.get_toplevel(), Gtk.FileChooserAction.SAVE, "_Save", "_Cancel"
+        )
         sel.set_local_only(True)
         sel.set_do_overwrite_confirmation(True)
         sel.set_current_name("Unnamed.pdf")
@@ -1762,7 +1882,7 @@
         return file_name
 
     def _take_screenshot(self, dummy_button):
-        #print "Cheese!"
+        # print "Cheese!"
         file_name = self._get_export_file_name()
         if file_name is None:
             return
@@ -1777,23 +1897,25 @@
         bounds.x2, bounds.y2 = self.canvas.convert_from_pixels(x2, y2)
         dest_width = bounds.x2 - bounds.x1
         dest_height = bounds.y2 - bounds.y1
-        #print bounds.x1, bounds.y1, " -> ", bounds.x2, bounds.y2
+        # print bounds.x1, bounds.y1, " -> ", bounds.x2, bounds.y2
 
         dummy, extension = os.path.splitext(file_name)
         extension = extension.lower()
-        if extension == '.eps':
+        if extension == ".eps":
             surface = cairo.PSSurface(file_name, dest_width, dest_height)
-        elif extension == '.pdf':
+        elif extension == ".pdf":
             surface = cairo.PDFSurface(file_name, dest_width, dest_height)
-        elif extension == '.svg':
+        elif extension == ".svg":
             surface = cairo.SVGSurface(file_name, dest_width, dest_height)
         else:
-            dialog = Gtk.MessageDialog(parent  = self.canvas.get_toplevel(),
-                                       flags   = Gtk.DialogFlags.DESTROY_WITH_PARENT,
-                                       type    = Gtk.MessageType.ERROR,
-                                       buttons = Gtk.ButtonsType.OK,
-                                       message_format = "Unknown extension '%s' (valid extensions are '.eps', '.svg', and '.pdf')"
-                                                        % (extension,))
+            dialog = Gtk.MessageDialog(
+                parent=self.canvas.get_toplevel(),
+                flags=Gtk.DialogFlags.DESTROY_WITH_PARENT,
+                type=Gtk.MessageType.ERROR,
+                buttons=Gtk.ButtonsType.OK,
+                message_format="Unknown extension '%s' (valid extensions are '.eps', '.svg', and '.pdf')"
+                % (extension,),
+            )
             dialog.run()
             dialog.destroy()
             return
@@ -1816,11 +1938,10 @@
             return
 
         self.shell_window = Gtk.Window()
-        self.shell_window.set_size_request(750,550)
+        self.shell_window.set_size_request(750, 550)
         self.shell_window.set_resizable(True)
         scrolled_window = Gtk.ScrolledWindow()
-        scrolled_window.set_policy(Gtk.PolicyType.AUTOMATIC,
-                                   Gtk.PolicyType.AUTOMATIC)
+        scrolled_window.set_policy(Gtk.PolicyType.AUTOMATIC, Gtk.PolicyType.AUTOMATIC)
         self.ipython = ipython_view.IPythonView()
         self.ipython.modify_font(Pango.FontDescription(SHELL_FONT))
         self.ipython.set_wrap_mode(Gtk.WrapMode.CHAR)
@@ -1829,11 +1950,10 @@
         scrolled_window.show()
         self.shell_window.add(scrolled_window)
         self.shell_window.show()
-        self.shell_window.connect('destroy', self._on_shell_window_destroy)
+        self.shell_window.connect("destroy", self._on_shell_window_destroy)
 
         self._update_ipython_selected_node()
-        self.ipython.updateNamespace({'viz': self})
-
+        self.ipython.updateNamespace({"viz": self})
 
     def _on_shell_window_destroy(self, window):
         self.shell_window = None
@@ -1841,6 +1961,7 @@
 
 initialization_hooks = []
 
+
 def add_initialization_hook(hook, *args):
     """
     Adds a callback to be called after
@@ -1852,12 +1973,14 @@
 
 
 def set_bounds(x1, y1, x2, y2):
-    assert x2>x1
-    assert y2>y1
+    assert x2 > x1
+    assert y2 > y1
+
     def hook(viz):
         cx1, cy1 = transform_point_simulation_to_canvas(x1, y1)
         cx2, cy2 = transform_point_simulation_to_canvas(x2, y2)
         viz.canvas.set_bounds(cx1, cy1, cx2, cy2)
+
     add_initialization_hook(hook)
 
 
@@ -1865,8 +1988,8 @@
     assert Visualizer.INSTANCE is None
     if _import_error is not None:
         import sys
-        print("No visualization support (%s)." % (str(_import_error),),
-              file=sys.stderr)
+
+        print("No visualization support (%s)." % (str(_import_error),), file=sys.stderr)
         ns.Simulator.Run()
         return
     load_plugins()
